    All Packages  Class Hierarchy  This Package  Previous  Next  Index

# Class java.awt.FontMetrics

    java.lang.Object
       |
       +----java.awt.FontMetrics

public abstract class FontMetrics
extends Object
implements Serializable

A font metrics object, which gives information about the rendering of a particular font on a particular screen. Note that the implementations of these methods are inefficient, they are usually overridden with more efficient toolkit-specific implementations.

Note to subclassers: Since many of these methods form closed mutually recursive loops, you must take care that you implement at least one of the methods in each such loop in order to prevent infinite recursion when your subclass is used. In particular, the following is the minimal suggested set of methods to override in order to ensure correctness and prevent infinite recursion (though other subsets are equally feasible):

- getAscent()
- getDescent()
- getLeading()
- getMaxAdvance()
- charWidth(char ch)
- charsWidth(char data[], int off, int len)

When an application asks AWT to place a character at the position (x, y), the character is placed so that its reference point (shown as the dot in the accompanying image) is put at that position. The reference point specifies a horizontal line called the baseline of the character. In normal printing, the baselines of characters should align.

In addition, every character in a font has an ascent, a descent, and an advance width. The ascent is the amount by which the character ascends above the baseline. The descent is the amount by which the character descends below the baseline. The advance width indicates the position at which AWT should place the next character.

If the current character is placed with its reference point at the position (x, y), and the character's advance width is w, then the following character is placed with its reference point at the position (x `+` w, y). The advance width is often the same as the width of character's bounding box, but need not be so. In particular, oblique and italic fonts often have characters whose top-right corner extends slightly beyond the advance width.

An array of characters or a string can also have an ascent, a descent, and an advance width. The ascent of the array is the maximum ascent of any character in the array. The descent is the maximum descent of any character in the array. The advance width is the sum of the advance widths of each of the characters in the array.

See Also:
  Font

##

font
  The actual font.

##

FontMetrics(Font)
  Creates a new `FontMetrics` object for finding out height and width information about the specified font and specific character glyphs in that font.

##

bytesWidth(byte[], int, int)
  Returns the total advance width for showing the specified array of bytes in this Font.
charsWidth(char[], int, int)
  Returns the total advance width for showing the specified array of characters in this Font.
charWidth(char)
  Returns the advance width of the specified character in this Font.
charWidth(int)
  Returns the advance width of the specified character in this Font.
getAscent()
  Determines the font ascent of the font described by this font metric.
getDescent()
  Determines the font descent of the font described by this font metric.
getFont()
  Gets the font described by this font metric.
getHeight()
  Gets the standard height of a line of text in this font.
getLeading()
  Determines the standard leading of the font described by this font metric.
getMaxAdvance()
  Gets the maximum advance width of any character in this Font.
getMaxAscent()
  Determines the maximum ascent of the font described by this font metric.
getMaxDecent()
  For backward compatibility only. Deprecated.
getMaxDescent()
  Determines the maximum descent of the font described by this font metric.
getWidths()
  Gets the advance widths of the first 256 characters in the Font.
stringWidth(String)
  Returns the total advance width for showing the specified String in this Font.
toString()
  Returns a representation of this `FontMetric` object's values as a string.

##

font

     protected Font font

  The actual font.

  See Also:
    getFont

##

FontMetrics

     protected FontMetrics(Font font)

  Creates a new `FontMetrics` object for finding out height and width information about the specified font and specific character glyphs in that font.

  Parameters:
    font - the font
  See Also:
    Font

##

getFont

     public Font getFont()

  Gets the font described by this font metric.

  Returns:
    the font described by this font metric.

getLeading

     public int getLeading()

  Determines the standard leading of the font described by this font metric. The standard leading (interline spacing) is the logical amount of space to be reserved between the descent of one line of text and the ascent of the next line. The height metric is calculated to include this extra space.

  Returns:
    the standard leading of the font.
  See Also:
    getHeight, getAscent, getDescent

getAscent

     public int getAscent()

  Determines the font ascent of the font described by this font metric. The font ascent is the distance from the font's baseline to the top of most alphanumeric characters. Some characters in the font may extend above the font ascent line.

  Returns:
    the font ascent of the font.
  See Also:
    getMaxAscent

getDescent

     public int getDescent()

  Determines the font descent of the font described by this font metric. The font descent is the distance from the font's baseline to the bottom of most alphanumeric characters with descenders. Some characters in the font may extend below the font descent line.

  Returns:
    the font descent of the font.
  See Also:
    getMaxDescent

getHeight

     public int getHeight()

  Gets the standard height of a line of text in this font. This is the distance between the baseline of adjacent lines of text. It is the sum of the leading + ascent + descent. There is no guarantee that lines of text spaced at this distance will be disjoint; such lines may overlap if some characters overshoot either the standard ascent or the standard descent metric.

  Returns:
    the standard height of the font.
  See Also:
    getLeading, getAscent, getDescent

getMaxAscent

     public int getMaxAscent()

  Determines the maximum ascent of the font described by this font metric. No character extends further above the font's baseline than this height.

  Returns:
    the maximum ascent of any character in the font.
  See Also:
    getAscent

getMaxDescent

     public int getMaxDescent()

  Determines the maximum descent of the font described by this font metric. No character extends further below the font's baseline than this height.

  Returns:
    the maximum descent of any character in the font.
  See Also:
    getDescent

getMaxDecent

     public int getMaxDecent()

  Note: getMaxDecent() is deprecated. As of JDK version 1.1.1, replaced by `getMaxDescent()`.

  For backward compatibility only.

  See Also:
    getMaxDescent

getMaxAdvance

     public int getMaxAdvance()

  Gets the maximum advance width of any character in this Font. The advance width is the amount by which the current point is moved from one character to the next in a line of text.

  Returns:
    the maximum advance width of any character in the font, or `-1` if the maximum advance width is not known.

charWidth

     public int charWidth(int ch)

  Returns the advance width of the specified character in this Font. The advance width is the amount by which the current point is moved from one character to the next in a line of text.

  Parameters:
    ch - the character to be measured
  Returns:
    the advance width of the specified `char` in the font described by this font metric.
  See Also:
    charsWidth, stringWidth

charWidth

     public int charWidth(char ch)

  Returns the advance width of the specified character in this Font. The advance width is the amount by which the current point is moved from one character to the next in a line of text.

  Parameters:
    ch - the character to be measured
  Returns:
    the advance width of the specified `char` > in the font described by this font metric.
  See Also:
    charsWidth, stringWidth

stringWidth

     public int stringWidth(String str)

  Returns the total advance width for showing the specified String in this Font. The advance width is the amount by which the current point is moved from one character to the next in a line of text.

  Parameters:
    str - the String to be measured
  Returns:
    the advance width of the specified string in the font described by this font metric.
  See Also:
    bytesWidth, charsWidth

charsWidth

     public int charsWidth(char data[],
                           int off,
                           int len)

  Returns the total advance width for showing the specified array of characters in this Font. The advance width is the amount by which the current point is moved from one character to the next in a line of text.

  Parameters:
    data - the array of characters to be measured
    off - the start offset of the characters in the array
    len - the number of characters to be measured from the array
  Returns:
    the advance width of the subarray of the specified `char` array in the font described by this font metric.
  See Also:
    charWidth, charWidth, bytesWidth, stringWidth

bytesWidth

     public int bytesWidth(byte data[],
                           int off,
                           int len)

  Returns the total advance width for showing the specified array of bytes in this Font. The advance width is the amount by which the current point is moved from one character to the next in a line of text.

  Parameters:
    data - the array of bytes to be measured
    off - the start offset of the bytes in the array
    len - the number of bytes to be measured from the array
  Returns:
    the advance width of the subarray of the specified `byte` array in the font described by this font metric.
  See Also:
    charsWidth, stringWidth

getWidths

     public int[] getWidths()

  Gets the advance widths of the first 256 characters in the Font. The advance width is the amount by which the current point is moved from one character to the next in a line of text.

  Returns:
    an array giving the advance widths of the characters in the font described by this font metric.

toString

     public String toString()

  Returns a representation of this `FontMetric` object's values as a string.

  Returns:
    a string representation of this font metric.
  Overrides:
    toString in class Object

    All Packages  Class Hierarchy  This Package  Previous  Next  Index

Submit a bug or feature - Version 1.1.8 of Java Platform API Specification
Java is a trademark or registered trademark of Sun Microsystems, Inc. in the US and other countries.
Copyright 1995-1999 Sun Microsystems, Inc. 901 San Antonio Road,
Palo Alto, California, 94303, U.S.A. All Rights Reserved.